## Comments, Questions, Feature Requests, Bug Reports
At this time, any kind of comment, question, feature request, or bug report is welcome in the issue tracker.
If you are asking a question, please search the issues for an answer before making a post.

## Code Contributions
Community-driven development and enhancement of WaterModels is welcomed and encouraged.
Please feel free to fork this repository and share your contributions to the master branch with a pull request.
That said, it is important to keep in mind the code quality requirements and scope of WaterModels before preparing a contribution.

### WaterModels Scope
The primary motivation for WaterModels is to help researchers quickly and easily replicate _established_ results in water systems optimization. 
More preliminary research and development efforts are best left to other packages that extend WaterModels.
That said, the WaterModels package should have a software design that makes building such extensions as easy as possible.

### Code Quality Requirements
WaterModels strives to be a user-friendly, highly-reliable, and well-maintained package.
To that end, the following code quality controls are necessary for all contributions:
- All features must have unit tests.
- Naming conventions must be consistent.
- Core features must have documentation.
- Code style must be consistent (e.g., four spaces for indentation).

Due to these quality control requirements, pull requests to WaterModels may require lengthy discussion and code review.
